/*
 *  LICENSE:
 *  Copyright (c) 2009 Freescale Semiconductor
 *  
 *  Permission is hereby granted, free of charge, to any person 
 *  obtaining a copy of this software and associated documentation 
 *  files (the "Software"), to deal in the Software without 
 *  restriction, including without limitation the rights to use, 
 *  copy, modify, merge, publish, distribute, sublicense, and/or 
 *  sell copies of the Software, and to permit persons to whom the 
 *  Software is furnished to do so, subject to the following 
 *  conditions:
 *  
 *  The above copyright notice and this permission notice 
 *  shall be included in all copies or substantial portions 
 *  of the Software.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
 *  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
 *  OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND 
 *  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
 *  HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
 *  WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
 *  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
 *  DEALINGS IN THE SOFTWARE.
 *  
 * Composed By: Sim, Mong Tee                                                 
 * Dated      : August 7, 2009                                                
 * Compiler   : Green Hill Multi
 */

#ifndef _STM_H_
#define _STM_H_


#include "mpc563m.h"

//-----------------------------------------------------------------------------
// STM API
//-----------------------------------------------------------------------------
#define STM_CLOCK               64                  // 64 Mhz             
#define STM_START               1
#define STM_ELAPSE              0
#define STM_us                  1
#define STM_ms                  1000
#define STM_sec                 1000000

void     STM_init               (uint32_t STM_CR);
uint32_t STM_read               (void);
uint32_t STM_elaspe             (uint32_t BeginTime);
void     STM_delay              (uint32_t delay);


#endif // _STM_H_  
